unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Spectrum3D, ExtCtrls, StdCtrls, BASS, jpeg, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    OpenDialog1: TOpenDialog;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    Spectrum3D1: TSpectrum3D;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrakBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Timer1Timer(Sender: TObject);
begin
    Spectrum3D1.Render;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    if OpenDialog1.Execute then begin
        BASS_StreamFree(Spectrum3D1.Channel);
        Spectrum3D1.Channel := BASS_StreamCreateFile(False, PChar(OpenDialog1.FileName), 0, 0, BASS_UNICODE OR BASS_STREAM_AUTOFREE);
        BASS_ChannelPlay(Spectrum3D1.Channel, True);
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    //* Initialize BASS
	if (HIWORD(BASS_GetVersion) <> BASSVERSION) then begin
		MessageDlg('BASS version 2.4 was not loaded!', mtError, [mbOk], 0);
		Halt;
	end;
	if not BASS_Init(-1, 44100, 0, Handle, nil) then begin
		MessageDlg('Cannot start default audio device!', mtError, [mbOk], 0);
	end;
    //* Set freme rendering to every 30th msec
    Timer1.Interval := 30;
    //* Fade the grid or not
    Spectrum3D1.GradientGrid := False;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    Spectrum3D1.Close;
    //* Unload BASS
    BASS_Stop;
    BASS_Free;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
    Spectrum3D1.GFXZoom := TrackBar1.Position;
end;

procedure TForm1.TrakBar2Change(Sender: TObject);
begin
    Spectrum3D1.GFXScroll := TrackBar2.Position;
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
    Spectrum3D1.GFXAmplitude := TrackBar3.Position;
end;

end.
